Index: code/branches/dynamicmatch/data/levels/gametype_dynamicmatch.oxw
===================================================================
--- code/branches/dynamicmatch/data/levels/gametype_dynamicmatch.oxw	(revision 6955)
+++ code/branches/dynamicmatch/data/levels/gametype_dynamicmatch.oxw	(revision 6987)
@@ -18,13 +18,13 @@
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
 
-<!-- Planet braucht noch Collisionshape und evtl. Gravitation-->
+<!-- ------------------Planet needs gravity----------------- -->
 <Planet position="0,0,0" scale=500 pitch=-90 mesh="iceplanet.mesh" atmosphere="atmosphere1" rotationaxis="8,1,0" rotationrate="1" atmospheresize=224.0f imagesize=1024.0f />
 <StaticEntity position="0,0,0" collisionType=static>
       <collisionShapes>
-        <SphereCollisionShape radius="500" />
+        <SphereCollisionShape radius="499" />
       </collisionShapes>
     </StaticEntity>
 
-<!-- Die Spawnpoints sollten auf der Oberlaeche des Planeten sein, so verteilt, dass Spieler sich nicht sehen; spaeter: Teamspawnpoints fuer chaser!!-->
+<!-- -----------12-Spawnpoints around the planet------------- -->
 <TeamSpawnPoint team=0 position="1000,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
 <TeamSpawnPoint team=0 position="-1000,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
@@ -33,4 +33,7 @@
 <TeamSpawnPoint team=0 position="0,0,1000" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
 <TeamSpawnPoint team=0 position="0,0,-1000" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
+<!--outer Spawnpoints -->
+<TeamSpawnPoint team=0 position="2000,0,0" lookat="0,0,1" spawnclass=SpaceShip pawndesign=spaceshipassff/>
+<TeamSpawnPoint team=0 position="-2000,0,0" lookat="0,0,-1" spawnclass=SpaceShip pawndesign=spaceshipassff/>
 <TeamSpawnPoint team=0 position="0,2000,0" lookat="0,1,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
 <TeamSpawnPoint team=0 position="0,-2000,0" lookat="0,-1,0" spawnclass=SpaceShip pawndesign=spaceshipassff/>
@@ -41,5 +44,5 @@
     dofile("includes/CuboidSpaceStation.lua")
   ?>
-<!--Rotating satellite -->
+<!-- ----------------Rotating satellite--------------- -->
 <MovableEntity position="1,1,1" rotationrate="-4.5" rotationaxis="0,0,1">
         <attached>
@@ -57,29 +60,5 @@
 </MovableEntity>
 
-<!--particleTest
- <ParticleEmitter position="800,800,800" source="Orxonox/Steam" >
-    </ParticleEmitter>
- <ParticleEmitter position="900,900,900" source="Orxonox/Steam" >
-    </ParticleEmitter>
- <ParticleEmitter position="700,700,700" source="Orxonox/Steam" >
-    </ParticleEmitter>
- <ParticleEmitter position="770,770,770" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,760,760" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,760,760" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,900,600" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,900,700" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,900,800" source="Orxonox/Steam" >
-    </ParticleEmitter>
-<ParticleEmitter position="760,900,900" source="Orxonox/Steam" >
-    </ParticleEmitter>
--->
-
-
-<!-- asteroid ellypse-->
+<!-- ---------------asteroid ellypse----------------- -->
 <?lua
 max = 20
@@ -96,12 +75,16 @@
 ?>
 
-    <MovableEntity position="<?lua print(x + math.random() * 1000-500) ?>,<?lua print(y + math.random() * 1000-500) ?>,<?lua print(z + math.random() * 5000-2500) ?>" <?lua if i == 5 then ?> collisionType=dynamic linearDamping=0.8 angularDamping=0 mass=<?lua print(j * 50) ?> <?lua end ?> scale=<?lua print(j * 5) ?> rotationaxis="<?lua print(math.random()) ?>, <?lua print(math.random()) ?>, <?lua print(math.random()) ?>" rotationrate="<?lua print(math.random() * 30 + 5) ?>">
+    <StaticEntity position="<?lua print(x + math.random() * 1000-500) ?>,<?lua print(y + math.random() * 1000-500) ?>,<?lua print(z + math.random() * 5000-2500) ?>" scale=<?lua print(j * 5) ?> >
       <attached>
-        <Model position="0,0,0" scale=<?lua print(j * 10) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" />
+        <Model position="0,0,0" scale=<?lua print(j * 10) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh">
+	  <attached><!-- ---------asteroid fog----- -->
+            <ParticleEmitter position="0,0,0" source="Orxonox/Steam" />
+          </attached>
+	</Model>
       </attached>
       <?lua if i == 5 then ?><collisionShapes>
         <SphereCollisionShape radius="<?lua print(j * 70) ?>" />
       </collisionShapes> <?lua end ?>
-    </MovableEntity>
+    </StaticEntity>
 <?lua
 end
@@ -116,6 +99,5 @@
       </events>
     </GlobalShader>
-
-<!--
+<!-- ----------------random fog --- not in use
 <?lua
 for i = 1, 100, 1
@@ -124,17 +106,14 @@
 ?>
 
-    <MovableEntity position="<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000 - 2000) ?>" collisionType=dynamic linearDamping=0.8 angularDamping=0 mass=<?lua print(j * 50) ?> scale=<?lua print(j * 5) ?> rotationaxis="<?lua print(math.random()) ?>, <?lua print(math.random()) ?>, <?lua print(math.random()) ?>" rotationrate="<?lua print(math.random() * 30 + 5) ?>">
+    <StaticEntity position="<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000 - 2000) ?>">
       <attached>
-        <Model position="0,0,0" scale=<?lua print(j * 10) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" />
+        <ParticleEmitter position="0,0,0" source="Orxonox/Steam" />
       </attached>
-      <collisionShapes>
-        <SphereCollisionShape radius="<?lua print(j * 70) ?>" />
-      </collisionShapes>
-    </MovableEntity>
+    </StaticEntity>
+
 <?lua
 end
 ?>
 -->
-
   </Scene>
 </Level>
Index: code/branches/dynamicmatch/data/overlays/dynamicmatchhud.oxo
===================================================================
--- code/branches/dynamicmatch/data/overlays/dynamicmatchhud.oxo	(revision 6955)
+++ code/branches/dynamicmatch/data/overlays/dynamicmatchhud.oxo	(revision 6987)
@@ -6,6 +6,6 @@
    position = "0.5, 0.01"
    font     = "VeraMono"
-   caption  = "Instructions"
-   textsize = 0.035
+   caption  = ""
+   textsize = 0.033
    colour   = "1.0, 1.0, 0.5, 1.0"
    align    = "center"
@@ -14,7 +14,7 @@
 <GametypeFadingMessage
      name     = "fadingmessage"
-     position = "0.25, 0.5"
+     position = "0.5, 0.05"
      font     = "VeraMono"
-     textsize = 0.035
+     textsize = 0.04
      colour   = "1.0, 1.0, 0.5, 1.0"
      align    = "center"