Index: trunk/src/lib/event/event_handler.cc
===================================================================
--- trunk/src/lib/event/event_handler.cc	(revision 6989)
+++ trunk/src/lib/event/event_handler.cc	(revision 6990)
@@ -260,7 +260,13 @@
   this->eventsGrabbed = grabEvents;
   if(!grabEvents)
+  {
+    SDL_ShowCursor(SDL_ENABLE);
     SDL_WM_GrabInput(SDL_GRAB_OFF);
-  else
+  }
+  else
+  {
     SDL_WM_GrabInput(SDL_GRAB_ON);
+    SDL_ShowCursor(SDL_DISABLE);
+  }
 }
 
Index: trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- trunk/src/lib/graphics/graphics_engine.cc	(revision 6989)
+++ trunk/src/lib/graphics/graphics_engine.cc	(revision 6990)
@@ -429,56 +429,4 @@
 
 /**
- *
- * @param show if The mouse-cursor should be visible
- */
-void GraphicsEngine::showMouse(bool show)
-{
-  if (show)
-    SDL_ShowCursor(SDL_ENABLE);
-  else
-    SDL_ShowCursor(SDL_DISABLE);
-}
-
-/**
- *
- * @returns The Visinility of the mouse-cursor (true if visible, false if it is invisible)
- */
-bool GraphicsEngine::isMouseVisible()
-{
-  if (SDL_ShowCursor(SDL_QUERY) == SDL_ENABLE)
-    return true;
-  else
-    return false;
-}
-
-/**
- *
- * @param steal If the Winodow-Managers Events should be stolen to this app
- * (steals the mouse, and all WM-clicks)
- *
- * This only happens, if the HARD-Debug-level is set to 0,1,2, because otherwise a Segfault could
- * result in the loss of System-controll
- */
-void GraphicsEngine::stealWMEvents(bool steal)
-{
-#if DEBUG < 3
-  if (steal)
-    SDL_WM_GrabInput(SDL_GRAB_ON);
-  else
-    SDL_WM_GrabInput(SDL_GRAB_OFF);
-#endif
-}
-
-/**
- *
- * @returns true if Events are stolen from the WM, false if not.
- */
-bool GraphicsEngine::isStealingEvents()
-{
-  if (SDL_WM_GrabInput(SDL_GRAB_QUERY) == SDL_GRAB_ON)
-    return true;
-  else
-    return false;
-};
 
 /**
Index: trunk/src/lib/graphics/graphics_engine.h
===================================================================
--- trunk/src/lib/graphics/graphics_engine.h	(revision 6989)
+++ trunk/src/lib/graphics/graphics_engine.h	(revision 6990)
@@ -56,9 +56,4 @@
 
     int resolutionChanged(const SDL_ResizeEvent& resizeInfo);
-
-    static void showMouse(bool show);
-    static bool isMouseVisible();
-    static void stealWMEvents(bool steal);
-    static bool isStealingEvents();
 
     static void enter2DMode();
Index: trunk/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6989)
+++ trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6990)
@@ -141,5 +141,6 @@
 
   LoadParam(root, "bind-node", this, Element2D, setBindNode)
-      .describe("sets a node, this 2D-Element should be shown upon (name of the node)");
+      .describe("sets a node, this 2D-Element should be shown upon (name of the node)")
+      .defaultValues(1, NULL);
 
   LoadParam(root, "visibility", this, Element2D, setVisibility)
Index: trunk/src/world_entities/creatures/md2_creature.cc
===================================================================
--- trunk/src/world_entities/creatures/md2_creature.cc	(revision 6989)
+++ trunk/src/world_entities/creatures/md2_creature.cc	(revision 6990)
@@ -106,6 +106,4 @@
 
   PRINTF(4)("MD2CREATURE INIT\n");
-
-  EventHandler::getInstance()->grabEvents(true);
 
   this->mouseDirX *= Quaternion( M_PI * 0.75f, Vector(0,1,0));
Index: trunk/src/world_entities/weapons/crosshair.cc
===================================================================
--- trunk/src/world_entities/weapons/crosshair.cc	(revision 6989)
+++ trunk/src/world_entities/weapons/crosshair.cc	(revision 6990)
@@ -48,9 +48,4 @@
   if (this->material)
   delete this->material;
-
-  // delete what has to be deleted here
-
-  GraphicsEngine::showMouse(true);
-  GraphicsEngine::stealWMEvents(false);
 }
 
@@ -73,8 +68,7 @@
 
   // center the mouse on the screen, and also hide the cursors
-  SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
+  /*  SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
   GraphicsEngine::showMouse(false);
-  GraphicsEngine::stealWMEvents(true);
-  SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
+  SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);*/
 }
 