Index: /trunk/src/story_entities/game_world.cc
===================================================================
--- /trunk/src/story_entities/game_world.cc	(revision 6991)
+++ /trunk/src/story_entities/game_world.cc	(revision 6992)
@@ -88,5 +88,4 @@
 
   this->dataXML = NULL;
-  this->path = NULL;
 }
 
@@ -111,7 +110,4 @@
 {
   StoryEntity::loadParams(root);
-
-  LoadParam(root, "path", this, GameWorld, setPath)
-      .describe("The Filename of this GameWorld (relative from the data-dir)");
 
   PRINTF(4)("Loaded GameWorld specific stuff\n");
@@ -145,9 +141,9 @@
   PRINTF(0)("Loading the GameWorld\n");
 
-  PRINTF(3)("> Loading world: '%s'\n", getPath());
+  PRINTF(3)("> Loading world: '%s'\n", getLoadFile());
   TiXmlElement* element;
   GameLoader* loader = GameLoader::getInstance();
 
-  if( getPath() == NULL)
+  if( getLoadFile() == NULL)
   {
     PRINTF(1)("GameWorld has no path specified for loading\n");
@@ -155,9 +151,9 @@
   }
 
-  TiXmlDocument* XMLDoc = new TiXmlDocument( getPath());
+  TiXmlDocument* XMLDoc = new TiXmlDocument( getLoadFile());
   // load the xml world file for further loading
   if( !XMLDoc->LoadFile())
   {
-    PRINTF(1)("loading XML File: %s @ %s:l%d:c%d\n", XMLDoc->ErrorDesc(), this->getPath(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
+    PRINTF(1)("loading XML File: %s @ %s:l%d:c%d\n", XMLDoc->ErrorDesc(), this->getLoadFile(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
     delete XMLDoc;
     return (ErrorMessage){213,"XML File parsing error","GameWorld::load()"};
@@ -444,26 +440,4 @@
 }
 
-
-/**
- *  sets the track path of this world
- * @param name the name of the path
- */
-void GameWorld::setPath( const char* name)
-{
-  if (this->path)
-    delete this->path;
-  if (ResourceManager::isFile(name))
-  {
-    this->path = new char[strlen(name)+1];
-    strcpy(this->path, name);
-  }
-  else
-  {
-    this->path = new char[strlen(ResourceManager::getInstance()->getDataDir()) + strlen(name) +1];
-    sprintf(this->path, "%s%s", ResourceManager::getInstance()->getDataDir(), name);
-  }
-}
-
-
 /**
  *  shows the loading screen
Index: /trunk/src/story_entities/game_world.h
===================================================================
--- /trunk/src/story_entities/game_world.h	(revision 6991)
+++ /trunk/src/story_entities/game_world.h	(revision 6992)
@@ -47,6 +47,4 @@
     inline void setSpeed(float speed) { this->speed = speed; };
     /**  returns the track path of this world @returns the track path */
-    const char* getPath() { return this->path; }
-    void setPath( const char* name);
 
     /** toggles the PNode visibility in the world (drawn as boxes) */
@@ -81,5 +79,4 @@
     GameWorldData*      dataTank;                     //!< reference to the GameWorld Data Tank
     TiXmlElement*       dataXML;                      //!< The XML-Element this World has been loaded with.
-    char*               path;                         //!< The file from which this world is loaded
 
     bool                showPNodes;                   //!< if the PNodes should be visible.
Index: /trunk/src/story_entities/simple_game_menu.cc
===================================================================
--- /trunk/src/story_entities/simple_game_menu.cc	(revision 6991)
+++ /trunk/src/story_entities/simple_game_menu.cc	(revision 6992)
@@ -243,5 +243,4 @@
   EventHandler::getInstance()->unsubscribe(this, ES_MENU);
 
-  std::vector<ImageEntity*>::iterator it;
   std::vector<MenuLayer>::iterator mit;
   for(mit = this->menuLayers.begin(); mit != this->menuLayers.end(); mit++)
Index: /trunk/src/story_entities/story_entity.cc
===================================================================
--- /trunk/src/story_entities/story_entity.cc	(revision 6991)
+++ /trunk/src/story_entities/story_entity.cc	(revision 6992)
@@ -22,4 +22,5 @@
 #include "story_entity.h"
 
+#include "resource_manager.h"
 #include "load_param.h"
 
@@ -39,4 +40,5 @@
   this->isRunning = false;
 
+  this->loadFile = NULL;
   this->storyID = -1;
   this->description = NULL;
@@ -66,4 +68,10 @@
       .describe("A Unique Identifier for this StoryEntity");
 
+  LoadParam(root, "path", this, StoryEntity, setLoadFile)
+      .describe("DEPRICATED FORM OF file. The Filename of this StoryEntity (relative from the data-dir)");
+
+  LoadParam(root, "file", this, StoryEntity, setLoadFile)
+      .describe("The Filename of this StoryEntity (relative from the data-dir)");
+
   LoadParam(root, "nextid", this, StoryEntity, setNextStoryID)
       .describe("Sets the ID of the next StoryEntity");
@@ -86,4 +94,22 @@
 
 /**
+ *  sets the track path of this world
+ * @param name the name of the path
+ */
+void StoryEntity::setLoadFile(const char* fileName)
+{
+  if (this->loadFile)
+    delete this->loadFile;
+  if (ResourceManager::isFile(fileName))
+  {
+    this->loadFile = new char[strlen(fileName)+1];
+    strcpy(this->loadFile, fileName);
+  }
+  else
+    this->loadFile = ResourceManager::getFullName(fileName);
+}
+
+
+/**
  * sets the descroption of this StoryEntity
  * @param name name
@@ -101,4 +127,14 @@
 }
 
+/**
+ * sets the id of the next story entity: StoryEntities can choose their following entity themselfs.
+ * the entity id defined here  will be startet after this entity ends. this can be convenient if you
+ * want to have a non linear story with switches.
+ * @param nextStoryID the story id of the next StoryEntity
+ */
+void StoryEntity::setNextStoryID(int nextStoryID)
+{
+   this->nextStoryID = nextStoryID;
+}
 
 /**
Index: /trunk/src/story_entities/story_entity.h
===================================================================
--- /trunk/src/story_entities/story_entity.h	(revision 6991)
+++ /trunk/src/story_entities/story_entity.h	(revision 6992)
@@ -60,14 +60,18 @@
   /** sets the story id of the current entity, this enables it to be identified in a  global context. @returns  the story id  */
   inline int getStoryID() { return this->storyID; }
-  /**  sets the id of the next story entity: StoryEntities can choose their following entity themselfs.
-   * the entity id defined here  will be startet after this entity ends. this can be convenient if you
-   * want to have a non linear story with switches.
-   * @param nextStoryID the story id of the next StoryEntity   */
-  inline void setNextStoryID(int nextStoryID) { this->nextStoryID = nextStoryID; }
+
+  void setLoadFile( const char* fileName);
+  /** @returns the Filename this StoryEntity was loaded with */
+  const char* getLoadFile() const { return this->loadFile; }
+
+  void setNextStoryID(int nextStoryID);
   /**  gets the story id of the current entity @returns story id */
-  inline int getNextStoryID() { return this->nextStoryID; }
+  inline int getNextStoryID() const { return this->nextStoryID; }
   inline void setDescription(const char* description);
   /** @returns the description of this StoryEntity */
   inline const char* getDescription() { return this->description; }
+
+
+
   /** toggle the menu visibility: SimpleMenu specific */
   inline void addToGameMenu(int toggle) { this->bMenuEntry = (bool)toggle; }
@@ -90,10 +94,12 @@
 
  private:
-    int storyID;            //!< this is the number of this entity, identifying it in a list/tree...
-    int nextStoryID;        //!< if this entity has finished, this entity shall be called
-    char* description;      //!< the description of the StoryEntity
-    char* menuItemImage;    //!< the item image of the StoryEntity
-    char* menuScreenshoot;  //!< the screenshoot of the StoryEntity
-    bool        bMenuEntry; //!< If true, this GameWorld apears in the SimpleMenu: SimpleMenu specific
+    int     storyID;          //!< this is the number of this entity, identifying it in a list/tree...
+    int     nextStoryID;      //!< if this entity has finished, this entity shall be called
+    char*   loadFile;         //!< The file from which this world is loaded
+
+    char*   description;      //!< the description of the StoryEntity
+    char*   menuItemImage;    //!< the item image of the StoryEntity
+    char*   menuScreenshoot;  //!< the screenshoot of the StoryEntity
+    bool    bMenuEntry;       //!< If true, this GameWorld apears in the SimpleMenu: SimpleMenu specific
 };
 