Index: code/branches/presentation3/data/levels/includes/pickups.oxi
===================================================================
--- code/branches/presentation3/data/levels/includes/pickups.oxi	(revision 6994)
+++ code/branches/presentation3/data/levels/includes/pickups.oxi	(revision 6998)
@@ -1,2 +1,36 @@
+<!-- Shield pickups -->
+
+<PickupRepresentation
+    pickupName = "Small Shield Pickup"
+    pickupDescription = "Gives you a small shield for 10 seconds."
+    inventoryRepresentation = "SmallShield"
+    spawnerTemplate = "smallshieldpickupRepresentation"
+>
+    <pickup>
+        <ShieldPickup template=smallshieldpickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    pickupName = "Medium Shield Pickup"
+    pickupDescription = "Gives you a medium-sized shield for 30 seconds."
+    inventoryRepresentation = "MediumShield"
+    spawnerTemplate = "mediumshieldpickupRepresentation"
+>
+    <pickup>
+        <ShieldPickup template=mediumshieldpickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    pickupName = "Huge Shield Pickup"
+    pickupDescription = "Gives you a big shield for 60 seconds."
+    inventoryRepresentation = "HugeShield"
+    spawnerTemplate = "hugeshieldpickupRepresentation"
+>
+    <pickup>
+        <ShieldPickup template=hugeshieldpickup />
+    </pickup>
+</PickupRepresentation>
 
 <!-- Health pickups -->
@@ -73,7 +107,8 @@
 
 <PickupRepresentation
-    name = "Small Speed Boost"
-    description = "Multiplies Speed of the Ship by a small amount."
+    pickupName = "Small Speed Boost"
+    pickupDescription = "Multiplies Speed of the Ship by a small amount."
     spawnerTemplate = "smallspeedpickupRepresentation"
+    inventoryRepresentation = "SmallSpeed"
 >
     <pickup>
@@ -83,7 +118,8 @@
 
 <PickupRepresentation
-    name = "Medium Speed Boost"
-    description = "Multiplies Speed of the Ship by a bigger amount."
+    pickupName = "Medium Speed Boost"
+    pickupDescription = "Multiplies Speed of the Ship by a bigger amount."
     spawnerTemplate = "mediumspeedpickupRepresentation"
+    inventoryRepresentation = "MediumSpeed"
 >
     <pickup>
@@ -93,7 +129,8 @@
 
 <PickupRepresentation
-    name = "Huge Speed Boost"
-    description = "Multiplies Speed of the Ship by a huge amount."
+    pickupName = "Huge Speed Boost"
+    pickupDescription = "Multiplies Speed of the Ship by a huge amount."
     spawnerTemplate = "hugespeedpickupRepresentation"
+    inventoryRepresentation = "HugeSpeed"
 >
     <pickup>
@@ -103,7 +140,8 @@
 
 <PickupRepresentation
-    name = "Small Jump Boost"
-    description = "Boosts the Ship with a massive amount for a very short time."
+    pickupName = "Small Jump Boost"
+    pickupDescription = "Boosts the Ship with a massive amount for a very short time."
     spawnerTemplate = "smalljumppickupRepresentation"
+    inventoryRepresentation = "SmallSpeed"
 >
     <pickup>
@@ -115,7 +153,8 @@
 
 <PickupRepresentation
-    name = "small Invisibility"
-    description = "Makes you invisible for 5 seconds."
+    pickupName = "Small Invisibility"
+    pickupDescription = "Makes you invisible for 5 seconds."
     spawnerTemplate = "smallinvisiblepickupRepresentation"
+    inventoryRepresentation = "SmallInvisible"
 >
     <pickup>
@@ -125,7 +164,8 @@
 
 <PickupRepresentation
-    name = "medium Invisibility"
-    description = "Makes you invisible for 10 seconds."
+    pickupName = "Medium Invisibility"
+    pickupDescription = "Makes you invisible for 10 seconds."
     spawnerTemplate = "mediuminvisiblepickupRepresentation"
+    inventoryRepresentation = "MediumInvisible"
 >
     <pickup>
@@ -135,7 +175,8 @@
 
 <PickupRepresentation
-    name = "hunge Invisibility"
-    description = "Makes you invisible for 20 seconds."
+    pickupName = "Huge Invisibility"
+    pickupDescription = "Makes you invisible for 20 seconds."
     spawnerTemplate = "hugeinvisiblepickupRepresentation"
+    inventoryRepresentation = "HugeInvisible"
 >
     <pickup>
Index: code/branches/presentation3/data/levels/pickup.oxw
===================================================================
--- code/branches/presentation3/data/levels/pickup.oxw	(revision 6994)
+++ code/branches/presentation3/data/levels/pickup.oxw	(revision 6998)
@@ -26,4 +26,25 @@
     <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
 
+
+    <!-- Shield pickups -->
+    
+    <PickupSpawner position="-25,-25,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+        <pickup>
+            <ShieldPickup template=smallshieldpickup />
+        </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="0,-25,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+        <pickup>
+            <ShieldPickup template=mediumshieldpickup />
+        </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="25,-25,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+        <pickup>
+            <ShieldPickup template=hugeshieldpickup />
+        </pickup>
+    </PickupSpawner>
+    
     <!-- Health pickups -->
     
@@ -114,5 +135,5 @@
     <!-- Pickup Collection pickups -->
     
-    <PickupSpawner position="0,-25,-100" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
+    <PickupSpawner position="0,100,-100" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
         <pickup>
             <PickupCollection template=triplehealthspeedinvisibilitypickup />
Index: code/branches/presentation3/data/levels/pickup_pps_invi.oxw
===================================================================
--- code/branches/presentation3/data/levels/pickup_pps_invi.oxw	(revision 6994)
+++ 	(revision )
@@ -1,46 +1,0 @@
-<?lua
-  include("stats.oxo")
-  include("hudtemplates3.oxo")
-?>
-
-<?lua
-  include("templates/spaceship_assff.oxt")
-  include("templates/spaceship_pirate.oxt")
-  include("templates/pickup_representation_templates.oxt")
-?>
-
-<Level
- name         = "Sample"
- description  = "Just a few tests"
->
-  <Scene
-    ambientlight = "0.8, 0.8, 0.8"
-    skybox       = "Orxonox/Starbox"
-  >
-
-<?lua
-  include("includes/pickups.oxi")
-?>
-
-    <PickupSpawner position="-75,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
-        <pickup>
-            <InvisiblePickup template=smallinvisiblepickup />
-        </pickup>
-    </PickupSpawner>
-
-    <PickupSpawner position="-50,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
-        <pickup>
-            <InvisiblePickup template=mediuminvisiblepickup />
-        </pickup>
-    </PickupSpawner>
-
-    <PickupSpawner position="-25,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
-        <pickup>
-            <InvisiblePickup template=hugeinvisiblepickup />
-        </pickup>
-    </PickupSpawner>
-
-    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-    <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
-  </Scene>
-</Level>
Index: code/branches/presentation3/data/levels/pickup_ppstest1.oxw
===================================================================
--- code/branches/presentation3/data/levels/pickup_ppstest1.oxw	(revision 6994)
+++ 	(revision )
@@ -1,98 +1,0 @@
-<?lua
-  include("stats.oxo")
-  include("hudtemplates3.oxo")
-?>
-
-<?lua
-  include("templates/spaceship_assff.oxt")
-  include("templates/spaceship_pirate.oxt")
-  include("templates/pickup_representation_templates.oxt")
-?>
-
-<Level
- name         = "Sample"
- description  = "Just a few tests"
->
-  <Scene
-    ambientlight = "0.8, 0.8, 0.8"
-    skybox       = "Orxonox/Starbox"
-  >
-
-<?lua
-  include("includes/pickups.oxi")
-?>
-
-    <PickupSpawner position="-25,0,-100" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
-        <pickup>
-            <SpeedPickup template=smallspeedpickup />
-        </pickup>
-    </PickupSpawner>
-
-    <PickupSpawner position="0,0,-100" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
-        <pickup>
-            <SpeedPickup template=mediumspeedpickup />
-        </pickup>
-    </PickupSpawner>
-
-    <PickupSpawner position="25,0,-100" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
-        <pickup>
-            <SpeedPickup template=hugespeedpickup />
-        </pickup>
-    </PickupSpawner>
-
-    <PickupSpawner position="50,0,-100" triggerDistance="10" respawnTime="10" maxSpawnedItems="99">
-        <pickup>
-            <SpeedPickup template=smalljumppickup />
-        </pickup>
-    </PickupSpawner>
-
-
-    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-    <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
-
-
-
-    <MovableEntity scale=1.5 position="0,0,-300" velocity="0,0,0" rotationaxis="0,1,0" rotationrate=90>
-      <events>
-        <activity>
-          <DistanceTrigger position="0,0,-300" distance=50 target="ControllableEntity" invert=1 />
-        </activity>
-      </events>
-      <attached>
-        <Model position="0,0,0" scale=10 mesh="ast1.mesh" />
-        <StaticEntity position="0,0,100">
-          <attached>
-            <Model position="0,0,0" scale=6 mesh="ast1.mesh" />
-            <MovableEntity position="0,0,0" velocity="0,0,0" rotationaxis="0,0,1" rotationrate=500>
-              <attached>
-                <Model position="0,35,0" scale=2 mesh="ast1.mesh" />
-                <Model position="0,-35,0" scale=2 mesh="ast1.mesh" />
-                <Model position="35,0,0" scale=2 mesh="ast1.mesh">
-                  <attached>
-                    <ParticleEmitter position="0,0,0" source="Orxonox/ExplosionComp4" />
-                  </attached>
-                </Model>
-                <Model position="-35,0,0" scale=2 mesh="ast1.mesh">
-                  <attached>
-                    <ParticleEmitter position="0,0,0" source="Orxonox/fire3" />
-                  </attached>
-                </Model>
-              </attached>
-            </MovableEntity>
-          </attached>
-        </StaticEntity>
-        <MovableEntity position="0,0,-100" velocity="0,0,0" rotationaxis="0,1,0" rotationrate=200>
-          <attached>
-            <ParticleEmitter position="0,0,0" source="Orxonox/fire3" />
-            <Model position="0,0,0" scale=6 mesh="ast1.mesh" />
-            <Model position="0,0,-50" scale=3 mesh="ast1.mesh" />
-            <Model position="0,0,50" scale=3 mesh="ast1.mesh" />
-          </attached>
-        </MovableEntity>
-      </attached>
-    </MovableEntity>
-
-    <ExplosionChunk position="-500,0,-200" lifetime=3.0 loop=1/>
-
-  </Scene>
-</Level>
Index: code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt
===================================================================
--- code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt	(revision 6994)
+++ code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt	(revision 6998)
@@ -1,2 +1,83 @@
+<!-- Shield pickups: -->
+
+<Template name=smallshieldpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="1,1,1" material="Sphere2" scale=0.1>
+                        <attached>
+                            <Billboard position="0,0,0" colour="1,1,1" material="Shield" scale=0.3 />
+                        </attached>
+                    </Billboard>
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=smallshieldpickup>
+  <ShieldPickup
+    duration = 10
+    shieldabsorption = 0.7
+    shieldhealth = 300
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
+
+
+<Template name=mediumshieldpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="1,1,1" material="Sphere2" scale=0.1>
+                        <attached>
+                            <Billboard position="0,0,0" colour="1,1,1" material="Shield" scale=0.5 />
+                        </attached>
+                    </Billboard>
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=mediumshieldpickup>
+  <ShieldPickup
+    duration = 30
+    shieldabsorption = 0.8
+    shieldhealth = 500
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
+
+
+<Template name=hugeshieldpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="1,1,1" material="Sphere2" scale=0.1>
+                        <attached>
+                            <Billboard position="0,0,0" colour="1,1,1" material="Shield" scale=0.7 />
+                        </attached>
+                    </Billboard>
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=hugeshieldpickup>
+  <ShieldPickup
+    duration = 60
+    shieldabsorption = 0.95
+    shieldhealth = 700
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
 
 <!-- Health pickups: -->