Index: trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.cc	(revision 7000)
+++ trunk/src/world_entities/space_ships/space_ship.cc	(revision 7001)
@@ -287,11 +287,4 @@
   Playable::collidesWith(entity, location);
 
-
-  if (entity->isA(CL_TURRET_POWER_UP) && entity != ref)
-  {
-    this->ADDWEAPON();
-    ref = entity;
-  }
-
   if( entity->isA(CL_PROJECTILE) && entity != ref)
   {
@@ -501,37 +494,4 @@
 }
 
-#include "weapons/aiming_turret.h"
-// FIXME THIS MIGHT BE CONSIDERED EITHER A FEATURE, OR A BUG
-void SpaceShip::ADDWEAPON()
-{
-  Weapon* turret = NULL;
-
-  if ((float)rand()/RAND_MAX < .9)
-  {
-    //if (this->getWeaponManager()->hasFreeSlot(2, WTYPE_TURRET))
-    {
-      turret = new Turret();
-      this->addWeapon(turret, 2);
-      this->getWeaponManager()->changeWeaponConfig(2);
-    }
-  }
-  else
-  {
-    //if (this->getWeaponManager()->hasFreeSlot(3))
-    {
-      turret = dynamic_cast<Weapon*>(Factory::fabricate(CL_TARGETING_TURRET));
-      if (turret != NULL)
-      this->addWeapon(turret, 3);
-
-      this->getWeaponManager()->changeWeaponConfig(3);
-    }
-  }
-
-  if(turret != NULL)
-  {
-    turret->setName("Turret");
-    turret->setStateDuration(WS_SHOOTING, (float)rand()/RAND_MAX*.5+.1);
-  }
-}
 
 #define MASK_bUp         1
Index: trunk/src/world_entities/space_ships/space_ship.h
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.h	(revision 7000)
+++ trunk/src/world_entities/space_ships/space_ship.h	(revision 7001)
@@ -49,7 +49,4 @@
     void doCollideNetwork( float energy );
 
-    // !! temporary !!
-    void ADDWEAPON();
-
     bool                  bUp;                //!< up button pressed.
     bool                  bDown;              //!< down button pressed.
Index: trunk/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 7000)
+++ trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 7001)
@@ -30,4 +30,6 @@
 
 #include "graphics_engine.h"
+#include "dot_emitter.h"
+#include "sprite_particles.h"
 
 using namespace std;
@@ -112,6 +114,6 @@
   this->cameraLook = 0.0f;
   this->rotation = 0.0f;
-  this->acceleration = 25.0f;
-  this->airFriction = 3.0f;
+  this->acceleration = 10.0f;
+  this->airFriction = 2.0f;
 
   // camera - issue
@@ -138,5 +140,32 @@
   this->rotorNodeRight.setRelCoor(0, 1.0, 2.3);
 
-  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
+  // PARTICLES
+  this->burstEmitter[0] = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter[0]->setParent(&this->rotorNodeLeft);
+  this->burstEmitter[0]->setRelCoor(0, -0.7, 0);
+  this->burstEmitter[0]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter[0]->setName("TurbineHover_Burst_emitter_Left");
+
+  this->burstEmitter[1] = new DotEmitter(200, 5.0, .01);
+  this->burstEmitter[1]->setParent(&this->rotorNodeRight);
+  this->burstEmitter[1]->setRelCoor(0, -0.7, 0);
+  this->burstEmitter[1]->setRelDir(Quaternion(-M_PI_2, Vector(0,0,1)));
+  this->burstEmitter[1]->setName("TurbineHover_Burst_emitter_Right");
+
+
+  this->burstSystem = new SpriteParticles(1000);
+  this->burstSystem->addEmitter(this->burstEmitter[0]);
+  this->burstSystem->addEmitter(this->burstEmitter[1]);
+  this->burstSystem->setName("SpaceShip_Burst_System");
+  ((SpriteParticles*)this->burstSystem)->setMaterialTexture("maps/radial-trans-noise.png");
+  this->burstSystem->setLifeSpan(1.0, .3);
+  this->burstSystem->setRadius(0.0, 1.5);
+  this->burstSystem->setRadius(0.05, 1.8);
+  this->burstSystem->setRadius(.5, .8);
+  this->burstSystem->setRadius(1.0, 0);
+  this->burstSystem->setColor(0.0, .7,.7,1,.5);
+  this->burstSystem->setColor(0.2, 0,0,0.8,.5);
+  this->burstSystem->setColor(0.5, .5,.5,.8,.3);
+  this->burstSystem->setColor(1.0, .8,.8,.8,.0);
 
 
@@ -153,4 +182,5 @@
   registerEvent(EV_MOUSE_MOTION);
 
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
 
   // WEAPON_MANAGER configuration
@@ -241,4 +271,8 @@
   this->movement(dt);
   this->rotorCycle += this->rotorSpeed * dt;
+
+  // TRYING TO FIX PNode.
+/*  this->cameraNode.setAbsCoorSoft(this->getAbsCoor() + Vector(0,5,0), 30);
+  this->cameraNode.setAbsDirSoft(this->getAbsDir(), 30);*/
 }
 
@@ -293,9 +327,9 @@
   this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
 
-  this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .03 +this->rotation, Vector(1,0,0)), 5);
-  this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .05+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-  this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .03 +this->rotation, Vector(1,0,0)), 5);
-  this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.05 -this->rotation + cameraLook, Vector(0,0,1)), 5);
+  this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
+  this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
+
+  this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
+  this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
 }
 
Index: trunk/src/world_entities/space_ships/turbine_hover.h
===================================================================
--- trunk/src/world_entities/space_ships/turbine_hover.h	(revision 7000)
+++ trunk/src/world_entities/space_ships/turbine_hover.h	(revision 7001)
@@ -9,4 +9,8 @@
 
 #include "playable.h"
+
+// Forward Declaration
+class ParticleEmitter;
+class ParticleSystem;
 
 class TurbineHover : public Playable
@@ -67,4 +71,6 @@
     float                 airViscosity;
 
+    ParticleEmitter*      burstEmitter[2];
+    ParticleSystem*       burstSystem;
 };
 